=== debian/changelog ===
boxes (1.3-1) unstable; urgency=medium

  * New upstream version 1.3
  * Update copyright years for debian/* packaging files
  * Refresh default-GLOBALCONF-for-Debian.patch
  * Refresh do-not-strip-boxes-binary-by-default.patch
  * Drop spelling-error-in-manpage.patch (applied upstream)

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 27 Feb 2019 06:55:46 +0100

boxes (1.2-4) unstable; urgency=medium

  * Add an initial Gitlab CI config file
  * debian/.gitlab-ci.yml: Update image used for Gitlab CI
  * Update .gitlab-ci.yml based on Salsa CI Team's template
  * GitLab CI/Lintian: install dpkg-dev, that ships dpkg-architecture, needed
    to run some Lintian checks
  * Replace home-made GitLab CI with the standard Salsa pipeline
  * Bump Debhelper compat level to 12
  * Declare compliance with Debian policy 4.3.0
  * Inject additional CFLAGS from dpkg-buildflags into build.
    The project uses a custom approach to pass additional CFLAGS for the
    build via the CFLAGS_ADDTL variable.

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 28 Dec 2018 17:03:32 +0100
