=== debian/control ===
Source: boxes
Section: text
Priority: optional
Maintainer: Salvatore Bonaccorso <carnil@debian.org>
Standards-Version: 4.3.0
Build-Depends: bison, debhelper-compat (= 12), flex
Vcs-Browser: https://salsa.debian.org/carnil/boxes
Vcs-Git: https://salsa.debian.org/carnil/boxes.git
Homepage: https://boxes.thomasjensen.com/
Rules-Requires-Root: no

Package: boxes
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: textmode box- and comment drawing filter
 Boxes is extremely configurable filter for adding and removing ASCII art
 (comments, for example) around chunks of text.  Most modern text editors
 support filtering text through external filters.  Boxes is such a filter.
