=== debian/rules ===
#!/usr/bin/make -f

export CFLAGS_ADDTL+=$(shell dpkg-buildflags --get CFLAGS)

%:
	dh $@
