=== debian/watch ===
version=3
https://boxes.thomasjensen.com/download boxes-(.*)\.src\.tar\.gz
https://github.com/ascii-boxes/boxes/releases /ascii-boxes/boxes/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz|zip)$
