=== debian/changelog ===
boxes (2.1.1-2) unstable; urgency=medium

  * debian/copyright: Clarify upstream copyright stanza.
    - Update copyright information according to current upstream files.
    - Refer to GPL-2 only for the upstream files.
  * Fix quoting of closing comment tags in config

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 12 Dec 2021 13:30:21 +0100

boxes (2.1.1-1) unstable; urgency=medium

  * New upstream version 2.1.1
  * Update copyright years for upstream files
  * Add Build-Depends on libunistring-dev
  * Add Build-Depends on libpcre2-dev
  * Refresh "Change default config path for Debian"
  * Drop "Don't strip boxes binary already in Makefile"
  * Add Build-Depends on xxd used in upstream testsuite
  * debian/control: Wrap and sort fields
  * d/tests/control: smoke-test: Add xxd to Depends
  * d/tests/control: smoke-test: Adapt replacement in testrunner script to use
    installed boxes binary
  * dh_install: Install boxes binary from the new temporary build directory
  * d/tests/smoke-test: Copy installed boxes-config to run the tests
  * debian/copyright: Drop superfluous file pattern stanza (files dropped
    upstream)
  * debian/upstream/metadata: Remove obsolete field Homepage

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 12 Dec 2021 09:12:08 +0100

boxes (1.3-2) unstable; urgency=medium

  [ Salsa Pipeline ]
  * Update salsa CI pipeline

  [ Jenkins ]
  * Update watch file format version to 4.
  * Bump debhelper from old 12 to 13.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update pattern for GitHub archive URLs from /<org>/<repo>/tags
    page/<org>/<repo>/archive/<tag> -> /<org>/<repo>/archive/refs/tags/<tag>.
  * Remove obsolete field Name from debian/upstream/metadata (already present
    in machine-readable debian/copyright).
  * Update standards version to 4.5.1, no changes needed.
  * Replace use of deprecated $ADTTMP with $AUTOPKGTEST_TMP.

  [ Salvatore Bonaccorso ]
  * Declare compliance with Debian policy 4.6.0
  * Update copyright years for debian/* packaging files
  * Rename Salsa CI configuration file to debian/salsa-ci.yml

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 11 Dec 2021 15:30:37 +0100
