=== debian/control ===
--- 
+++ 
@@ -2,8 +2,14 @@
 Section: text
 Priority: optional
 Maintainer: Salvatore Bonaccorso <carnil@debian.org>
-Standards-Version: 4.3.0
-Build-Depends: bison, debhelper-compat (= 12), flex
+Standards-Version: 4.6.0
+Build-Depends:
+ bison,
+ debhelper-compat (= 13),
+ flex,
+ libpcre2-dev,
+ libunistring-dev,
+ xxd <!nocheck>
 Vcs-Browser: https://salsa.debian.org/carnil/boxes
 Vcs-Git: https://salsa.debian.org/carnil/boxes.git
 Homepage: https://boxes.thomasjensen.com/
