## boxes 2.2.0

=== Makefile ===
--- 
+++ 
@@ -2,42 +2,43 @@
 # boxes - Command line filter to draw/remove ASCII boxes around text
 # Copyright (c) 1999-2021 Thomas Jensen and the boxes contributors
 #
-# This program is free software; you can redistribute it and/or modify it
-# under the terms of the GNU General Public License, version 2, as published
-# by the Free Software Foundation.
-#
-# This program is distributed in the hope that it will be useful, but
-# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
-# for more details.
-#
-# You should have received a copy of the GNU General Public License along
-# with this program; if not, write to the Free Software Foundation, Inc.,
-# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
-#____________________________________________________________________________
-#============================================================================
+# This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public
+# License, version 3, as published by the Free Software Foundation.
+# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
+# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+# details.
+# You should have received a copy of the GNU General Public License along with this program.
+# If not, see <https://www.gnu.org/licenses/>.
+#____________________________________________________________________________________________________________________
+#====================================================================================================================
 
 
 # The following line (GLOBALCONF) is the only line you should need to edit!
 GLOBALCONF = /usr/share/boxes
 GIT_STATUS = $(shell git describe --dirty --always 2>/dev/null || echo "n/a")
-BVERSION   = 2.1.1
+BVERSION   = 2.2.0
 
 ALL_FILES  = LICENSE README.md boxes-config
 DOC_FILES  = doc/boxes.1 doc/boxes.el
 PKG_NAME   = boxes-$(BVERSION)
 OUT_DIR    = out
 
-WIN_PCRE2_VERSION      = 10.36
-WIN_PCRE2_DIR          = pcre2-$(WIN_PCRE2_VERSION)
+WIN_PCRE2_VERSION      = 10.40
+WIN_PCRE2_DIR          = vendor/pcre2-$(WIN_PCRE2_VERSION)
 WIN_FLEX_BISON_VERSION = 2.5.24
-WIN_FLEX_BISON_DIR     = flex_bison_$(WIN_FLEX_BISON_VERSION)
+WIN_FLEX_BISON_DIR     = vendor/flex_bison_$(WIN_FLEX_BISON_VERSION)
+WIN_CMOCKA_VERSION     = 1.1.0
+WIN_CMOCKA_DIR         = vendor/cmocka-$(WIN_CMOCKA_VERSION)
 
-.PHONY: clean build win32 debug win32.debug win32.pcre infomsg replaceinfos test package win32.package package_common
+.PHONY: clean build cov win32 debug win32.debug win32.pcre infomsg replaceinfos test covtest \
+        package win32.package package_common utest win32.utest
 
-# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 
-build debug: infomsg replaceinfos
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+#    Build
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+
+build cov debug: infomsg replaceinfos
 	$(MAKE) -C src BOXES_PLATFORM=unix LEX=flex YACC=bison $@
 
 win32: infomsg replaceinfos
@@ -50,11 +51,14 @@
 
 win32.prereq:
 	# download components
-	curl -LO https://ftp.pcre.org/pub/pcre/pcre2-$(WIN_PCRE2_VERSION).tar.gz
+	curl -LO https://github.com/PCRE2Project/pcre2/releases/download/pcre2-$(WIN_PCRE2_VERSION)/pcre2-$(WIN_PCRE2_VERSION).tar.gz
 	curl -LO https://downloads.sourceforge.net/project/winflexbison/win_flex_bison-$(WIN_FLEX_BISON_VERSION).zip
+	curl -LO https://cmocka.org/files/$(WIN_CMOCKA_VERSION:%.0=%)/cmocka-$(WIN_CMOCKA_VERSION)-mingw.zip
 	# unpack components
-	tar xfz $(WIN_PCRE2_DIR).tar.gz
+	mkdir -p vendor
 	unzip win_flex_bison-$(WIN_FLEX_BISON_VERSION).zip -d $(WIN_FLEX_BISON_DIR)
+	tar -C vendor -xzf pcre2-$(WIN_PCRE2_VERSION).tar.gz
+	unzip cmocka-$(WIN_CMOCKA_VERSION)-mingw.zip -d vendor
 	# build the pcre2 dependency (only needed on Windows MinGW)
 	cd $(WIN_PCRE2_DIR) ; \
 	./configure --disable-pcre2-8 --disable-pcre2-16 --enable-pcre2-32 --disable-shared \
@@ -63,8 +67,9 @@
 	# remove downloaded archives
 	rm pcre2-$(WIN_PCRE2_VERSION).tar.gz
 	rm win_flex_bison-$(WIN_FLEX_BISON_VERSION).zip
+	rm cmocka-$(WIN_CMOCKA_VERSION)-mingw.zip
 
-# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 
 infomsg:
 	@echo "| For compilation info please refer to the boxes compilation FAQ"
@@ -88,7 +93,10 @@
 	rm -f doc/boxes.1.raw.html
 	@echo "Conversion complete. Excessive manual work remains."
 
-# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+#    Standalone Packaging (Unix / Windows)
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 
 $(OUT_DIR)/$(PKG_NAME).tar.gz:
 	mkdir -p $(OUT_DIR)/$(PKG_NAME)/doc
@@ -116,7 +124,10 @@
 
 win32.package: win32 $(OUT_DIR)/zip/$(PKG_NAME).zip
 
-# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+#    Chocolatey Packaging (Windows)
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 
 choco: tools/LICENSE.txt tools/boxes.cfg tools/boxes.exe
 	choco pack --version=$(BVERSION)
@@ -132,17 +143,33 @@
 
 $(OUT_DIR)/boxes.exe: win32
 
-# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+#    Test
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+
+test:
+	cd test; ./testrunner.sh --suite
+
+covtest:
+	cd test; ./testrunner.sh --suite --coverage
+
+utest:
+	$(MAKE) -C utest BOXES_PLATFORM=unix utest
+
+win32.utest: $(OUT_DIR)
+	cp $(WIN_CMOCKA_DIR)/bin/cmocka.dll $(OUT_DIR)/
+	$(MAKE) -C utest BOXES_PLATFORM=win32 C_INCLUDE_PATH=../$(WIN_PCRE2_DIR)/src:../$(WIN_CMOCKA_DIR)/include \
+	    LDFLAGS_ADDTL="-L../$(WIN_PCRE2_DIR)/.libs -L../$(WIN_CMOCKA_DIR)/lib" utest
+
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+#    Cleanup
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 
 clean:
 	rm -f $(OUT_DIR)/boxes.h tools/boxes.cfg tools/LICENSE.txt tools/boxes.exe tools/README*.md boxes.portable.*.nupkg
 	rm -f doc/boxes.1 doc/boxes.1.raw.html doc/boxes.1.html
 	$(MAKE) -C src clean
 
-# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
-
-test:
-	cd test; ./testrunner.sh -suite
-
 
 #EOF
