=== src/Makefile ===
--- 
+++ 
@@ -2,20 +2,15 @@
 # boxes - Command line filter to draw/remove ASCII boxes around text
 # Copyright (c) 1999-2021 Thomas Jensen and the boxes contributors
 #
-# This program is free software; you can redistribute it and/or modify it
-# under the terms of the GNU General Public License, version 2, as published
-# by the Free Software Foundation.
-#
-# This program is distributed in the hope that it will be useful, but
-# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
-# for more details.
-#
-# You should have received a copy of the GNU General Public License along
-# with this program; if not, write to the Free Software Foundation, Inc.,
-# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
-#____________________________________________________________________________
-#============================================================================
+# This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public
+# License, version 3, as published by the Free Software Foundation.
+# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
+# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+# details.
+# You should have received a copy of the GNU General Public License along with this program.
+# If not, see <https://www.gnu.org/licenses/>.
+#____________________________________________________________________________________________________________________
+#====================================================================================================================
 
 
 CC         = gcc
@@ -37,26 +32,32 @@
 ORIG_FILES = $(ORIG_SRC) $(ORIG_HDR)
 
 
-.PHONY: check_dir clean build debug package flags_unix flags_win32 flags_
+.PHONY: check_dir clean build cov debug package flags_unix flags_win32 flags_
 
 .NOTPARALLEL:
 
 check_dir:
 	@if [ "$(shell pwd | sed -e 's/^.*\///')" != "out" ] ; then \
 	    echo ERROR: Please call make from the top level directory. ; \
-		exit 1 ; \
+	    exit 1 ; \
 	fi
 
 $(OUT_DIR):
 	mkdir $(OUT_DIR)
 
 build: flags_$(BOXES_PLATFORM) | $(OUT_DIR)
-	$(MAKE) -C $(OUT_DIR) -f $(SRC_DIR)/Makefile BOXES_PLATFORM=$(BOXES_PLATFORM) ALL_OBJ="$(ALL_OBJ)" \
-	    CFLAGS_ADDTL="-O $(CFLAGS_ADDTL)" STRIP=true flags_$(BOXES_PLATFORM) $(BOXES_EXECUTABLE_NAME)
+	$(MAKE) -C $(OUT_DIR) -f $(SRC_DIR)/Makefile BOXES_PLATFORM=$(BOXES_PLATFORM) ALL_OBJ="$(ALL_OBJ)" STRIP=true \
+	    CFLAGS_ADDTL="-O $(CFLAGS_ADDTL)" flags_$(BOXES_PLATFORM) $(BOXES_EXECUTABLE_NAME)
+
+cov: flags_$(BOXES_PLATFORM) | $(OUT_DIR)
+	$(MAKE) -C $(OUT_DIR) -f $(SRC_DIR)/Makefile BOXES_PLATFORM=$(BOXES_PLATFORM) ALL_OBJ="$(ALL_OBJ)" STRIP=false \
+	    CFLAGS_ADDTL="-g --coverage $(CFLAGS_ADDTL)" \
+	    LDFLAGS_ADDTL="--coverage $(LDFLAGS_ADDTL)" \
+	    flags_$(BOXES_PLATFORM) $(BOXES_EXECUTABLE_NAME)
 
 debug: flags_$(BOXES_PLATFORM) | $(OUT_DIR)
-	$(MAKE) -C $(OUT_DIR) -f $(SRC_DIR)/Makefile BOXES_PLATFORM=$(BOXES_PLATFORM) ALL_OBJ="$(ALL_OBJ)" \
-	    CFLAGS_ADDTL="-g $(CFLAGS_ADDTL)" STRIP=false flags_$(BOXES_PLATFORM) $(BOXES_EXECUTABLE_NAME)
+	$(MAKE) -C $(OUT_DIR) -f $(SRC_DIR)/Makefile BOXES_PLATFORM=$(BOXES_PLATFORM) ALL_OBJ="$(ALL_OBJ)" STRIP=false \
+	    CFLAGS_ADDTL="-g $(CFLAGS_ADDTL)" flags_$(BOXES_PLATFORM) $(BOXES_EXECUTABLE_NAME)
 
 boxes: $(ALL_OBJ) | check_dir
 	$(CC) $(LDFLAGS) $^ -o $@ -lunistring -lpcre2-32
@@ -69,15 +70,17 @@
 
 flags_unix:
 	$(eval CFLAGS := -I. -I$(SRC_DIR) -Wall -W $(CFLAGS_ADDTL))
-	$(eval LDFLAGS := $(LDFLAGS_ADDTL))
+	$(eval LDFLAGS := $(LDFLAGS) $(LDFLAGS_ADDTL))
 	$(eval BOXES_EXECUTABLE_NAME := boxes)
 	$(eval ALL_OBJ := $(GEN_SRC:.c=.o) $(ORIG_NORM:.c=.o))
+	echo $(filter-out boxes.o,$(ALL_OBJ)) > $(OUT_DIR)/modules.txt
 
 flags_win32:
 	$(eval CFLAGS := -Os -s -m32 -I. -I$(SRC_DIR) -Wall -W $(CFLAGS_ADDTL))
-	$(eval LDFLAGS := -s -m32)
+	$(eval LDFLAGS := $(LDFLAGS) -s -m32)
 	$(eval BOXES_EXECUTABLE_NAME := boxes.exe)
 	$(eval ALL_OBJ := $(GEN_SRC:.c=.o) $(ORIG_NORM:.c=.o) getopt.o)
+	echo $(filter-out boxes.o,$(ALL_OBJ)) > $(OUT_DIR)/modules.txt
 
 flags_:
 	@echo Please call make from the top level directory.
@@ -107,9 +110,11 @@
 tools.o:     tools.c tools.h boxes.h shape.h unicode.h config.h | check_dir
 unicode.o:   unicode.c unicode.h boxes.h tools.h config.h | check_dir
 
+
 package: $(BOXES_EXECUTABLE_NAME)
 	if [ -z "$(PKG_NAME)" ] ; then exit 1 ; fi
 	cp -a $(BOXES_EXECUTABLE_NAME) $(PKG_NAME)/
+
 
 clean:
 	rm -rf $(OUT_DIR)
