=== debian/changelog ===
boxes (2.2.0-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Defer stripping to dh_strip. (Closes: #1023275)

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 01 Nov 2022 21:52:00 +0100

boxes (2.2.0-1) unstable; urgency=medium

  * debian/watch: Switch to watch tagged versions on github releases page
  * New upstream version 2.2.0
  * debian/copyright: Clarify upstream's license is GPL-3 only
  * Refresh "Change default config path for Debian" patch
  * Drop "Fix quoting of closing comment tags in config" (applied upstream)
  * Declare compliance with Debian policy 4.6.1
  * Update copyright years for debian/* packaging files
  * d/t/smoke-test: Adjust replacement to reference installed boxes binary
  * d/t/smoke-test: Create fake empty output directory in temporary
    autopkgtest directory
  * d/t/smoke-test: Correct argument to testrunner script
  * d/t/smoke-test: Really fix the replacement to use installed binary

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 23 Sep 2022 12:06:21 +0200
