=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: text
 Priority: optional
 Maintainer: Salvatore Bonaccorso <carnil@debian.org>
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Build-Depends:
  bison,
  debhelper-compat (= 13),
