=== debian/rules ===
#!/usr/bin/make -f

export CFLAGS_ADDTL+=-O $(shell dpkg-buildflags --get CFLAGS)

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- debug
